<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Event propagation</title>
</head>
<body>
    <h1>Event propagation</h1>

    <h3>bubbling (html attribute <em>onclick</em>)</h3>
    <ul id="ul1" onclick="onClick(event)">
        <li id="li1" onclick="onClick(event)">Uno <em id="em1" onclick="onClick(event)">1</em></li>
        <li id="li2" onclick="onClick(event)">Due <em id="em2">2</em></li>
        <li id="li3">Tre <em id="em3">3</em></li>
    </ul>
    <script>
        function onClick(event){
            // NB: "this" equivale a "event.currentTarget"
            // console.log('Clicked element ->', event.target, 'Event listener element:', event.currentTarget, this);
            printEvent(onClick.name,event)
        }
        function printEvent(name,event){
            console.log(name,{
                clickedElement: event.target,
                eventListenerElement: event.currentTarget,
                thisElement: event.currentTarget,
                eventPhase: event.eventPhase === 1 ? 'capturing' : event.eventPhase === 2 ? 'target' : 'bubbling'
            })
        }
    </script>
<hr>
    <h3>bubbling, target, capturing (event <em>listener</em>)</h3>
    <ul id="ul2">
        <li id="li21">Uno <em id="em21">1</em></li>
        <li id="li22">Due <em id="em22">2</em></li>
        <li id="li23">Tre <em id="em23">3</em></li>
    </ul>
    <script>
        // document.querySelector('#ul2').addEventListener('click',onClick)
        // document.querySelectorAll('*').forEach(
        document.querySelectorAll('#ul2,#ul2 li,#ul2 > li > em')
        .forEach(
            function(element){
                // capturing
                element.addEventListener('click',onClick,true)
                // bubbling
                element.addEventListener('click',onClick)
            })

    </script>
    <hr>
    <h3>Stop onClick</h3>
    <ul id="ul3">
        <li id="li31">Uno <em id="em31">1</em></li>
        <li id="li32">Due <em id="em32">2</em></li>
        <li id="li33">Tre <em id="em33">3</em></li>
    </ul>
    <script>
        function onClickStop(event){
            printEvent(onClickStop.name,event)
            event.stopPropagation();
            // event.stopImmediatePropagation();
        }
        document.querySelectorAll('#ul3,#ul3 li,#ul3 > li > em').forEach(
            function(e){
                e.addEventListener('click',onClickStop,true)
                e.addEventListener('click',onClickStop)
            })
    </script>
</body>
</html>

